default persistent.modGalleryUnlock = False

init 999 screen imagegallery():
    tag menu


    python:
        import math

        GALLERY_SIZE = len(persistent.image_list)
        GALLERY_COLUMNS = 4
        GALLERY_ROWS = int(math.ceil((float(GALLERY_SIZE) / GALLERY_COLUMNS)))
        EMPTY_COUNT = GALLERY_ROWS * GALLERY_COLUMNS - GALLERY_SIZE

    use game_menu(_("Photo Gallery\n{font=fonts/rose.ttf}{size=-10}{space=20}Check out these images you unlocked while playing!{/font}{/size}"), scroll="viewport"):

        style_prefix "underconst"

        frame:
            xsize 1340 yfill

            ypadding 30
            background Frame([ "gui/confirm_frame.png", "gui/frame2.png"], gui.confirm_frame_borders, tile=gui.frame_tile)
            has vbox
            vbox:

                null height 50
                grid GALLERY_COLUMNS GALLERY_ROWS:
                    spacing 10
                    left_margin 45
                    for image_item in persistent.image_list:
                        if persistent.modGalleryUnlock:

                            vbox:
                                imagebutton:
                                    idle image_item.unlocked_idle_image
                                    hover image_item.unlocked_hover_image
                                    action Function(image_item.open_image)
                                text _(image_item.item_name) xalign 0.5 font "fonts/rose.ttf"
                        else:

                            vbox:

                                imagebutton:
                                    idle image_item.locked_image
                                text _(image_item.item_name) xalign 0.5 font "fonts/rose.ttf"
                    for i in range(EMPTY_COUNT):
                        null

    if persistent.modGalleryUnlock:
        textbutton _("Lock Photos") action SetVariable("persistent.modGalleryUnlock", False) xalign 0.908 yalign 0.235
    else:
        textbutton _("Unlock Photos") action SetVariable("persistent.modGalleryUnlock", True) xalign 0.9065 yalign 0.235

screen image_gallery_focus(pic):
    modal True zorder 10
    add '#00000090' at fade
    add pic at fade
    button background None action Hide('image_gallery_focus')

init:
    transform fade():
        alpha 1
        xalign .5 yalign .5
        on show:
            alpha 0
            easein .5 alpha 1
        on hide:
            easeout .5 alpha 0

init python:
    def scale_proportionally(img):
        currentwidth, currentheight = get_size(img)
        xscale = float(config.screen_width) / float(currentwidth)
        yscale = float(config.screen_height) / float(currentheight)

        if xscale < yscale:
            minscale = xscale
        else:
            minscale = yscale

        return im.FactorScale(img,minscale,minscale)

    def get_size(d):
        d = renpy.easy.displayable(d)
        w, h = renpy.render(d, 0, 0, 0, 0).get_size()
        w, h = int(round(w)), int(round(h))
        return w, h


init 999 screen scenegallery():
    tag menu

    python:
        import math

        GALLERY_SIZE = len(persistent.scene_list)
        GALLERY_COLUMNS = 4
        GALLERY_ROWS = int(math.ceil((float(GALLERY_SIZE) / GALLERY_COLUMNS)))
        EMPTY_COUNT = GALLERY_ROWS * GALLERY_COLUMNS - GALLERY_SIZE

    use game_menu(_("Scene Gallery\n{font=fonts/rose.ttf}{size=-10}{space=20}Replay your favorite moments!{/font}{/size}"), scroll="viewport"):
        style_prefix "underconst"

        frame:
            xsize 1340 yfill

            ypadding 30
            background Frame([ "gui/confirm_frame.png", "gui/frame2.png"], gui.confirm_frame_borders, tile=gui.frame_tile)
            has vbox

            vbox:

                null height 50
                grid GALLERY_COLUMNS GALLERY_ROWS:
                    left_margin 45
                    spacing 10
                    for scene_element in persistent.scene_list:
                        if persistent.modGalleryUnlock:

                            vbox:
                                imagebutton:
                                    idle scene_element.unlocked_idle_image
                                    hover scene_element.unlocked_hover_image
                                    action Replay(scene_element.label_name, locked = False)
                                text _(scene_element.item_name) xalign 0.5 font "fonts/rose.ttf"

                        else:

                            vbox:
                                imagebutton:
                                    idle scene_element.locked_image
                                text _(scene_element.item_name) xalign 0.5 font "fonts/rose.ttf"

                                if len(scene_element.multi_part_unlocks) > 0:
                                    hbox:
                                        for persistent_variable_name in scene_element.multi_part_unlocks:
                                            if getattr(persistent, persistent_variable_name) == True:
                                                add "multi_part_unlocked"
                                            else:
                                                add "multi_part_locked"
                    for i in range(EMPTY_COUNT):
                        null
    if persistent.modGalleryUnlock:
        textbutton _("Lock Scenes") action SetVariable("persistent.modGalleryUnlock", False) xalign 0.908 yalign 0.235
    else:
        textbutton _("Unlock Scenes") action SetVariable("persistent.modGalleryUnlock", True) xalign 0.9065 yalign 0.235

default persistent.achievementsUnlock = False

style achievement_title:
    color "#000000"
    font "fonts/javacom.otf"
    size 36

style achievement_description:
    color "#000000"
    font "fonts/rose.ttf"
    size 32

style achievement_secret_counter:
    color "#000000"
    font "fonts/rose.ttf"
    size 96

init 999 screen achievements():
    tag menu

    use game_menu(_("Achievements\n{space=20}{font=fonts/rose.ttf}{size=-10}Unlock these achievements as you play!{/font}{/size}"), scroll="viewport"):
        style_prefix "underconst"

        if persistent.achievementsUnlock:
            textbutton _("Lock Achievements") action SetVariable("persistent.achievementsUnlock", False)
        else:
            textbutton _("Unlock Achievements") action SetVariable("persistent.achievementsUnlock", True)

        frame:
            xsize 1380 yfill

            bottom_padding 40
            background Frame([ "gui/confirm_frame.png", "gui/frame2.png"], gui.confirm_frame_borders, tile=gui.frame_tile)
            has vbox
            vbox:
                xpos 120
                null height 50
                $ total_secret_achievements = 0

                for achievement in persistent.achievements:
                    if (achievement.is_locked == False) or persistent.achievementsUnlock:
                        frame:
                            background "achievement_unlocked_background"
                            xsize 1115
                            ysize 168
                            left_padding 5
                            has hbox:
                                yalign 0.5
                                yoffset -4
                            null width 16
                            add achievement.unlocked_thumbnail_image
                            null width 19
                            vbox:
                                yalign 0.5
                                text _(achievement.title) style "achievement_title"
                                text _(achievement.description) style "achievement_description"
                        null height 16

                    if (achievement.is_locked == True and achievement.is_secret == True):
                        $ total_secret_achievements += 1

                for achievement in persistent.achievements:
                    if (achievement.is_locked == True and achievement.is_secret == False):
                        frame:
                            background "achievement_locked_background"
                            xsize 1115
                            ysize 168
                            has hbox:
                                yalign 0.5
                            null width 16
                            add achievement.locked_thumbnail_image
                            null width 19
                            vbox:
                                yalign 0.5
                                text _(achievement.title) style "achievement_title"
                                text _(achievement.description) style "achievement_description"
                        null height 16

                if (total_secret_achievements > 0):
                    frame:
                        background "achievement_locked_background"
                        xsize 1115
                        ysize 168
                        has hbox:
                            yalign 0.5
                        null width 16
                        frame:
                            background None

                            xsize 248
                            text _("+%d" % total_secret_achievements):
                                style "achievement_secret_counter"
                                xalign 0.5
                        null width 16
                        vbox:
                            text _("Hidden achievements remain") style "achievement_title"
                            text _("Details for each will be revealed once unlocked.") style "achievement_description"
                    null height 16
